Loading...
Searching...
No Matches
juce::ChannelRemappingAudioSource Class Reference

`#include <juce_ChannelRemappingAudioSource.h>`

Inheritance diagram for juce::ChannelRemappingAudioSource:

## Public Member Functions

| ChannelRemappingAudioSource (AudioSource *source, bool deleteSourceWhenDeleted)
| ~ChannelRemappingAudioSource () override
void | setNumberOfChannelsToProduce (int requiredNumberOfChannels)
void | clearAllMappings ()
void | setInputChannelMapping (int destChannelIndex, int sourceChannelIndex)
void | setOutputChannelMapping (int sourceChannelIndex, int destChannelIndex)
int | getRemappedInputChannel (int inputChannelIndex) const
int | getRemappedOutputChannel (int outputChannelIndex) const
std::unique_ptr< XmlElement > | createXml () const
void | restoreFromXml (const XmlElement &)
void | prepareToPlay (int samplesPerBlockExpected, double sampleRate) override
void | releaseResources () override
void | getNextAudioBlock (const AudioSourceChannelInfo &) override
Public Member Functions inherited from juce::AudioSource
virtual | ~AudioSource ()=default

## Additional Inherited Members

Protected Member Functions inherited from juce::AudioSource
| AudioSource ()=default

## Detailed Description

An AudioSource that takes the audio from another source, and re-maps its input and output channels to a different arrangement.

You can use this to increase or decrease the number of channels that an audio source uses, or to re-order those channels.

Call the reset() method before using it to set up a default mapping, and then the setInputChannelMapping() and setOutputChannelMapping() methods to create an appropriate mapping, otherwise no channels will be connected and it'll produce silence.

See also
  AudioSource

Definition at line 43 of file juce_ChannelRemappingAudioSource.h.

## Constructor & Destructor Documentation

## ChannelRemappingAudioSource()

juce::ChannelRemappingAudioSource::ChannelRemappingAudioSource | ( | AudioSource * | source,
|  | bool | deleteSourceWhenDeleted )

Creates a remapping source that will pass on audio from the given input.

Parameters

  source | the input source to use. Make sure that this doesn't get deleted before the ChannelRemappingAudioSource object
  deleteSourceWhenDeleted | if true, the input source will be deleted when this object is deleted, if false, the caller is responsible for its deletion

Definition at line 26 of file juce_ChannelRemappingAudioSource.cpp.

## ~ChannelRemappingAudioSource()

juce::ChannelRemappingAudioSource::~ChannelRemappingAudioSource | ( |  | ) |

override

Destructor.

Definition at line 35 of file juce_ChannelRemappingAudioSource.cpp.

## Member Function Documentation

## clearAllMappings()

void juce::ChannelRemappingAudioSource::clearAllMappings | ( |  | ) |

Clears any mapped channels.

After this, no channels are mapped, so this object will produce silence. Create some mappings with setInputChannelMapping() and setOutputChannelMapping().

Definition at line 44 of file juce_ChannelRemappingAudioSource.cpp.

Referenced by restoreFromXml().

## createXml()

std::unique_ptr< XmlElement > juce::ChannelRemappingAudioSource::createXml | ( |  | ) | const

Returns an XML object to encapsulate the state of the mappings.

See also
  restoreFromXml

Definition at line 148 of file juce_ChannelRemappingAudioSource.cpp.

## getNextAudioBlock()

void juce::ChannelRemappingAudioSource::getNextAudioBlock | ( | const AudioSourceChannelInfo & | bufferToFill | ) |

override virtual

Called repeatedly to fetch subsequent blocks of audio data.

After calling the prepareToPlay() method, this callback will be made each time the audio playback hardware (or whatever other destination the audio data is going to) needs another block of data.

It will generally be called on a high-priority system thread, or possibly even an interrupt, so be careful not to do too much work here, as that will cause audio glitches!

See also
  AudioSourceChannelInfo, prepareToPlay, releaseResources

Implements juce::AudioSource.

Definition at line 103 of file juce_ChannelRemappingAudioSource.cpp.

## getRemappedInputChannel()

int juce::ChannelRemappingAudioSource::getRemappedInputChannel | ( | int | inputChannelIndex | ) | const

Returns the channel from our input that will be sent to channel inputChannelIndex of our input audio source.

Definition at line 72 of file juce_ChannelRemappingAudioSource.cpp.

Referenced by getNextAudioBlock().

## getRemappedOutputChannel()

int juce::ChannelRemappingAudioSource::getRemappedOutputChannel | ( | int | outputChannelIndex | ) | const

Returns the output channel to which channel outputChannelIndex of our input audio source will be sent to.

Definition at line 82 of file juce_ChannelRemappingAudioSource.cpp.

Referenced by getNextAudioBlock().

## prepareToPlay()

void juce::ChannelRemappingAudioSource::prepareToPlay | ( | int | samplesPerBlockExpected,
|  | double | sampleRate )

override virtual

Tells the source to prepare for playing.

An AudioSource has two states: prepared and unprepared.

The prepareToPlay() method is guaranteed to be called at least once on an 'unprepared' source to put it into a 'prepared' state before any calls will be made to getNextAudioBlock(). This callback allows the source to initialise any resources it might need when playing.

Once playback has finished, the releaseResources() method is called to put the stream back into an 'unprepared' state.

Note that this method could be called more than once in succession without a matching call to releaseResources(), so make sure your code is robust and can handle that kind of situation.

Parameters

  samplesPerBlockExpected | the number of samples that the source will be expected to supply each time its getNextAudioBlock() method is called. This number may vary slightly, because it will be dependent on audio hardware callbacks, and these aren't guaranteed to always use a constant block size, so the source should be able to cope with small variations.
  sampleRate | the sample rate that the output will be used at - this is needed by sources such as tone generators.

See also
  releaseResources, getNextAudioBlock

Implements juce::AudioSource.

Definition at line 93 of file juce_ChannelRemappingAudioSource.cpp.

## releaseResources()

void juce::ChannelRemappingAudioSource::releaseResources | ( |  | ) |

override virtual

Allows the source to release anything it no longer needs after playback has stopped.

This will be called when the source is no longer going to have its getNextAudioBlock() method called, so it should release any spare memory, etc. that it might have allocated during the prepareToPlay() call.

Note that there's no guarantee that prepareToPlay() will actually have been called before releaseResources(), and it may be called more than once in succession, so make sure your code is robust and doesn't make any assumptions about when it will be called.

See also
  prepareToPlay, getNextAudioBlock

Implements juce::AudioSource.

Definition at line 98 of file juce_ChannelRemappingAudioSource.cpp.

## restoreFromXml()

void juce::ChannelRemappingAudioSource::restoreFromXml | ( | const XmlElement & | e | ) |

Restores the mappings from an XML object created by createXML().

See also
  createXml

Definition at line 167 of file juce_ChannelRemappingAudioSource.cpp.

## setInputChannelMapping()

void juce::ChannelRemappingAudioSource::setInputChannelMapping | ( | int | destChannelIndex,
|  | int | sourceChannelIndex )

Creates an input channel mapping.

When the getNextAudioBlock() method is called, the data in channel sourceChannelIndex of the incoming data will be sent to destChannelIndex of our input source.

Parameters

  destChannelIndex | the index of an input channel in our input audio source (i.e. the source specified when this object was created).
  sourceChannelIndex | the index of the input channel in the incoming audio data buffer during our getNextAudioBlock() callback

Definition at line 52 of file juce_ChannelRemappingAudioSource.cpp.

## setNumberOfChannelsToProduce()

void juce::ChannelRemappingAudioSource::setNumberOfChannelsToProduce | ( | int | requiredNumberOfChannels | ) |

Specifies a number of channels that this audio source must produce from its getNextAudioBlock() callback.

Definition at line 38 of file juce_ChannelRemappingAudioSource.cpp.

## setOutputChannelMapping()

void juce::ChannelRemappingAudioSource::setOutputChannelMapping | ( | int | sourceChannelIndex,
|  | int | destChannelIndex )

Creates an output channel mapping.

When the getNextAudioBlock() method is called, the data returned in channel sourceChannelIndex by our input audio source will be copied to channel destChannelIndex of the final buffer.

Parameters

  sourceChannelIndex | the index of an output channel coming from our input audio source (i.e. the source specified when this object was created).
  destChannelIndex | the index of the output channel in the incoming audio data buffer during our getNextAudioBlock() callback

Definition at line 62 of file juce_ChannelRemappingAudioSource.cpp.

The documentation for this class was generated from the following files:

- juce_ChannelRemappingAudioSource.h
- juce_ChannelRemappingAudioSource.cpp